
#include "imageField.h"

imageField::imageField() {}

void imageField::setupFieldFromImage(string filename, int w, int h) {
  ofImage image;
  unsigned char* pixels;
  int byteCount;
  int Bpp;
  
  image.setUseTexture(false);
  image.loadImage(filename);
  if(image.type != OF_IMAGE_COLOR) {
    cout << "imageField only supports OF_IMAGE_COLOR type images!" << endl;
    throw 100;
    return;
  }
  
  setupField(image.width, image.height, w, h);
  
  pixels = image.getPixels();
  Bpp = image.bpp/8;
  byteCount = image.width * image.height * Bpp;
  
  for(int i=0,j=0; i < byteCount; i++,j=i/Bpp) {
    switch(i%3) {
      case 0: // red
        field[j].x = (pixels[i] - 128) / 32.0;
        break;
        
      case 1: // green
        field[j].y = (pixels[i] - 128) / 32.0;
        break;
        
      case 2: // blue
        // field[j].z = pixels[i] - 128;
        break;
    }
    
  }
}